=== modified file 'ChangeLog'
--- ChangeLog	2006-07-21 18:18:20 +0000
+++ ChangeLog	2006-07-24 14:32:01 +0000
@@ -1,3 +1,10 @@
+2006-07-24  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
+
+    * olive.glade: improvements to the Commit dialog
+    * olive/frontend/gtk/commit.py: merged Jelmer Vernooij's integration branch
+      and some code from bzr-gtk (select files to commit)
+    * TODO: added some wishlist stuff
+
 2006-07-21  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
 
     * olive/olive.glade: some UI refreshment (push, remove and commit dialog)

=== modified file 'TODO'
--- TODO	2006-07-17 14:00:33 +0000
+++ TODO	2006-07-24 14:32:01 +0000
@@ -2,3 +2,7 @@
 -------------------
 
  - Be able to install into other locations than /usr (LarstiQ)
+ - Investigate TortoiseSVN-like commit/add dialogs (LarstiQ)
+   http://samba.org/~jelmer/bzr/gcommit.png
+ - HIGify the interface (Matthieu Moy)
+ - Consistent placement of buttons (Matthieu Moy)

=== modified file 'olive.glade'
--- olive.glade	2006-07-21 18:18:20 +0000
+++ olive.glade	2006-07-24 14:32:01 +0000
@@ -431,8 +431,8 @@
 	    <widget class="GtkScrolledWindow" id="scrolledwindow_left">
 	      <property name="visible">True</property>
 	      <property name="can_focus">True</property>
-	      <property name="hscrollbar_policy">GTK_POLICY_ALWAYS</property>
-	      <property name="vscrollbar_policy">GTK_POLICY_ALWAYS</property>
+	      <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
+	      <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
 	      <property name="shadow_type">GTK_SHADOW_NONE</property>
 	      <property name="window_placement">GTK_CORNER_TOP_LEFT</property>
 
@@ -460,8 +460,8 @@
 	    <widget class="GtkScrolledWindow" id="scrolledwindow_right">
 	      <property name="visible">True</property>
 	      <property name="can_focus">True</property>
-	      <property name="hscrollbar_policy">GTK_POLICY_ALWAYS</property>
-	      <property name="vscrollbar_policy">GTK_POLICY_ALWAYS</property>
+	      <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
+	      <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
 	      <property name="shadow_type">GTK_SHADOW_NONE</property>
 	      <property name="window_placement">GTK_CORNER_TOP_LEFT</property>
 
@@ -533,57 +533,149 @@
       <property name="spacing">3</property>
 
       <child>
-	<widget class="GtkLabel" id="label_commit">
-	  <property name="visible">True</property>
-	  <property name="label" translatable="yes">Please specify a commit message:</property>
-	  <property name="use_underline">False</property>
-	  <property name="use_markup">False</property>
-	  <property name="justify">GTK_JUSTIFY_LEFT</property>
-	  <property name="wrap">False</property>
-	  <property name="selectable">False</property>
-	  <property name="xalign">0</property>
-	  <property name="yalign">0.5</property>
-	  <property name="xpad">0</property>
-	  <property name="ypad">0</property>
-	  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
-	  <property name="width_chars">-1</property>
-	  <property name="single_line_mode">False</property>
-	  <property name="angle">0</property>
-	</widget>
-	<packing>
-	  <property name="padding">0</property>
-	  <property name="expand">False</property>
-	  <property name="fill">False</property>
-	</packing>
-      </child>
-
-      <child>
-	<widget class="GtkScrolledWindow" id="scrolledwindow_commit">
+	<widget class="GtkVPaned" id="vpaned_commit">
 	  <property name="visible">True</property>
 	  <property name="can_focus">True</property>
-	  <property name="hscrollbar_policy">GTK_POLICY_ALWAYS</property>
-	  <property name="vscrollbar_policy">GTK_POLICY_ALWAYS</property>
-	  <property name="shadow_type">GTK_SHADOW_NONE</property>
-	  <property name="window_placement">GTK_CORNER_TOP_LEFT</property>
-
-	  <child>
-	    <widget class="GtkTextView" id="textview_commit">
-	      <property name="visible">True</property>
-	      <property name="can_focus">True</property>
-	      <property name="editable">True</property>
-	      <property name="overwrite">False</property>
-	      <property name="accepts_tab">True</property>
-	      <property name="justification">GTK_JUSTIFY_LEFT</property>
-	      <property name="wrap_mode">GTK_WRAP_NONE</property>
-	      <property name="cursor_visible">True</property>
-	      <property name="pixels_above_lines">0</property>
-	      <property name="pixels_below_lines">0</property>
-	      <property name="pixels_inside_wrap">0</property>
-	      <property name="left_margin">0</property>
-	      <property name="right_margin">0</property>
-	      <property name="indent">0</property>
-	      <property name="text" translatable="yes"></property>
-	    </widget>
+	  <property name="position">120</property>
+
+	  <child>
+	    <widget class="GtkVBox" id="vbox_commit_select">
+	      <property name="visible">True</property>
+	      <property name="homogeneous">False</property>
+	      <property name="spacing">0</property>
+
+	      <child>
+		<widget class="GtkLabel" id="label_commit_select">
+		  <property name="visible">True</property>
+		  <property name="label" translatable="yes">Please select the file(s) to commit:</property>
+		  <property name="use_underline">False</property>
+		  <property name="use_markup">False</property>
+		  <property name="justify">GTK_JUSTIFY_LEFT</property>
+		  <property name="wrap">False</property>
+		  <property name="selectable">False</property>
+		  <property name="xalign">0</property>
+		  <property name="yalign">0.5</property>
+		  <property name="xpad">0</property>
+		  <property name="ypad">0</property>
+		  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+		  <property name="width_chars">-1</property>
+		  <property name="single_line_mode">False</property>
+		  <property name="angle">0</property>
+		</widget>
+		<packing>
+		  <property name="padding">0</property>
+		  <property name="expand">False</property>
+		  <property name="fill">False</property>
+		</packing>
+	      </child>
+
+	      <child>
+		<widget class="GtkScrolledWindow" id="scrolledwindow_commit_select">
+		  <property name="visible">True</property>
+		  <property name="can_focus">True</property>
+		  <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
+		  <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
+		  <property name="shadow_type">GTK_SHADOW_NONE</property>
+		  <property name="window_placement">GTK_CORNER_TOP_LEFT</property>
+
+		  <child>
+		    <widget class="GtkTreeView" id="treeview_commit_select">
+		      <property name="visible">True</property>
+		      <property name="can_focus">True</property>
+		      <property name="headers_visible">True</property>
+		      <property name="rules_hint">False</property>
+		      <property name="reorderable">False</property>
+		      <property name="enable_search">True</property>
+		      <property name="fixed_height_mode">False</property>
+		      <property name="hover_selection">False</property>
+		      <property name="hover_expand">False</property>
+		    </widget>
+		  </child>
+		</widget>
+		<packing>
+		  <property name="padding">0</property>
+		  <property name="expand">True</property>
+		  <property name="fill">True</property>
+		</packing>
+	      </child>
+	    </widget>
+	    <packing>
+	      <property name="shrink">True</property>
+	      <property name="resize">False</property>
+	    </packing>
+	  </child>
+
+	  <child>
+	    <widget class="GtkVBox" id="vbox_commit_message">
+	      <property name="visible">True</property>
+	      <property name="homogeneous">False</property>
+	      <property name="spacing">0</property>
+
+	      <child>
+		<widget class="GtkLabel" id="label_commit_message">
+		  <property name="visible">True</property>
+		  <property name="label" translatable="yes">Please specify a commit message:</property>
+		  <property name="use_underline">False</property>
+		  <property name="use_markup">False</property>
+		  <property name="justify">GTK_JUSTIFY_LEFT</property>
+		  <property name="wrap">False</property>
+		  <property name="selectable">False</property>
+		  <property name="xalign">0</property>
+		  <property name="yalign">0.5</property>
+		  <property name="xpad">0</property>
+		  <property name="ypad">0</property>
+		  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+		  <property name="width_chars">-1</property>
+		  <property name="single_line_mode">False</property>
+		  <property name="angle">0</property>
+		</widget>
+		<packing>
+		  <property name="padding">0</property>
+		  <property name="expand">False</property>
+		  <property name="fill">False</property>
+		</packing>
+	      </child>
+
+	      <child>
+		<widget class="GtkScrolledWindow" id="scrolledwindow_commit_message">
+		  <property name="visible">True</property>
+		  <property name="can_focus">True</property>
+		  <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
+		  <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
+		  <property name="shadow_type">GTK_SHADOW_NONE</property>
+		  <property name="window_placement">GTK_CORNER_TOP_LEFT</property>
+
+		  <child>
+		    <widget class="GtkTextView" id="textview_commit">
+		      <property name="visible">True</property>
+		      <property name="can_focus">True</property>
+		      <property name="editable">True</property>
+		      <property name="overwrite">False</property>
+		      <property name="accepts_tab">True</property>
+		      <property name="justification">GTK_JUSTIFY_LEFT</property>
+		      <property name="wrap_mode">GTK_WRAP_NONE</property>
+		      <property name="cursor_visible">True</property>
+		      <property name="pixels_above_lines">0</property>
+		      <property name="pixels_below_lines">0</property>
+		      <property name="pixels_inside_wrap">0</property>
+		      <property name="left_margin">0</property>
+		      <property name="right_margin">0</property>
+		      <property name="indent">0</property>
+		      <property name="text" translatable="yes"></property>
+		    </widget>
+		  </child>
+		</widget>
+		<packing>
+		  <property name="padding">0</property>
+		  <property name="expand">True</property>
+		  <property name="fill">True</property>
+		</packing>
+	      </child>
+	    </widget>
+	    <packing>
+	      <property name="shrink">True</property>
+	      <property name="resize">True</property>
+	    </packing>
 	  </child>
 	</widget>
 	<packing>
@@ -747,7 +839,7 @@
 	<packing>
 	  <property name="padding">0</property>
 	  <property name="expand">False</property>
-	  <property name="fill">True</property>
+	  <property name="fill">False</property>
 	</packing>
       </child>
     </widget>

=== modified file 'olive/frontend/gtk/commit.py'
--- olive/frontend/gtk/commit.py	2006-07-21 18:18:20 +0000
+++ olive/frontend/gtk/commit.py	2006-07-24 14:32:01 +0000
@@ -24,11 +24,15 @@
 try:
     import gtk
     import gtk.glade
+    import gobject
 except:
     sys.exit(1)
 
-import olive.backend.commit as commit
-import olive.backend.errors as errors
+from bzrlib.delta import compare_trees
+import bzrlib.errors as errors
+from bzrlib.workingtree import WorkingTree
+
+from dialog import OliveDialog
 
 class OliveCommit:
     """ Display Commit dialog and perform the needed actions. """
@@ -39,6 +43,30 @@
         
         self.comm = comm
         
+        self.dialog = OliveDialog(self.gladefile)
+        
+        # Check if current location is a branch
+        try:
+            (self.wt, path) = WorkingTree.open_containing(self.comm.get_path())
+            branch = self.wt.branch
+        except errors.NotBranchError:
+            self.notbranch = True
+            return
+        except:
+            raise
+
+        file_id = self.wt.path2id(path)
+
+        self.notbranch = False
+        if file_id is None:
+            self.notbranch = True
+            return
+        
+        # Set the delta
+        self.old_tree = self.wt.branch.repository.revision_tree(self.wt.branch.last_revision())
+        self.delta = compare_trees(self.old_tree, self.wt)
+        
+        # Get the Commit dialog widget
         self.window = self.glade.get_widget('window_commit')
         
         # Dictionary for signal_autoconnect
@@ -47,15 +75,57 @@
         
         # Connect the signals to the handlers
         self.glade.signal_autoconnect(dic)
+        
+        # Create the file list
+        self._create_file_view()
     
     def display(self):
         """ Display the Push dialog. """
-        self.window.show_all()
+        if self.notbranch:
+            self.dialog.error_dialog('Directory is not a branch.')
+        else:
+            self.window.show_all()
+    
+    # This code is from Jelmer Vernooij's bzr-gtk branch
+    def _create_file_view(self):
+        self.file_store = gtk.ListStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING, gobject.TYPE_STRING)
+        self.file_view = self.glade.get_widget('treeview_commit_select')
+        self.file_view.set_model(self.file_store)
+        crt = gtk.CellRendererToggle()
+        crt.set_property("activatable", True)
+        crt.connect("toggled", self._toggle_commit, self.file_store)
+        self.file_view.append_column(gtk.TreeViewColumn("Commit",crt,active=0))
+        self.file_view.append_column(gtk.TreeViewColumn("Path",gtk.CellRendererText(),text=1))
+        self.file_view.append_column(gtk.TreeViewColumn("Type",gtk.CellRendererText(),text=2))
+
+        for path, id, kind in self.delta.added:
+            self.file_store.append([ True, path, "added" ])
+
+        for path, id, kind in self.delta.removed:
+            self.file_store.append([ True, path, "removed" ])
+
+        for oldpath, newpath, id, kind, text_modified, meta_modified in self.delta.renamed:
+            self.file_store.append([ True, oldpath, "renamed"])
+
+        for path, id, kind, text_modified, meta_modified in self.delta.modified:
+            self.file_store.append([ True, path, "modified"])
+    
+    def _get_specific_files(self):
+        ret = []
+        it = self.file_store.get_iter_first()
+        while it:
+            if self.file_store.get_value(it, 0):
+                ret.append(self.file_store.get_value(it,1))
+            it = self.file_store.iter_next(it)
+
+        return ret
+    # end of bzr-gtk code
+    
+    def _toggle_commit(self, cell, path, model):
+        model[path][0] = not model[path][0]
+        return
     
     def commit(self, widget):
-        from dialog import OliveDialog
-        dialog = OliveDialog(self.gladefile)
-        
         textview = self.glade.get_widget('textview_commit')
         textbuffer = textview.get_buffer()
         start, end = textbuffer.get_bounds()
@@ -65,31 +135,32 @@
         checkbutton_strict = self.glade.get_widget('checkbutton_commit_strict')
         checkbutton_force = self.glade.get_widget('checkbutton_commit_force')
         
+        specific_files = self._get_specific_files()
+        
+        # merged from Jelmer Vernooij's olive integration branch
         try:
-            commit.commit([self.comm.get_path()], message, None,
-                          checkbutton_force.get_active(),
-                          checkbutton_strict.get_active(),
-                          checkbutton_local.get_active())
+            self.wt.commit(message, 
+                           allow_pointless=checkbutton_force.get_active(),
+                           strict=checkbutton_strict.get_active(),
+                           local=checkbutton_local.get_active(),
+                           specific_files=specific_files)
         except errors.NotBranchError:
-            dialog.error_dialog('Directory is not a branch.')
+            self.dialog.error_dialog('Directory is not a branch.')
             return
         except errors.LocalRequiresBoundBranch:
-            dialog.error_dialog('Local commit requires a bound branch.')
-            return
-        except errors.EmptyMessageError:
-            dialog.error_dialog('Commit message is empty.')
-            return
-        except errors.NoChangesToCommitError:
-            dialog.error_dialog('No changes to commit. Try force commit.')
-            return
-        except errors.ConflictsInTreeError:
-            dialog.error_dialog('Conflicts in tree. Please resolve them first.')
-            return
-        except errors.StrictCommitError:
-            dialog.error_dialog('Strict commit failed. There are unknown files.')
+            self.dialog.error_dialog('Local commit requires a bound branch.')
+            return
+        except errors.PointlessCommit:
+            self.dialog.error_dialog('No changes to commit. Try force commit.')
+            return
+        except errors.ConflictsInTree:
+            self.dialog.error_dialog('Conflicts in tree. Please resolve them first.')
+            return
+        except errors.StrictCommitFailed:
+            self.dialog.error_dialog('Strict commit failed. There are unknown files.')
             return
         except errors.BoundBranchOutOfDate, errmsg:
-            dialog.error_dialog('Bound branch is out of date: %s' % errmsg)
+            self.dialog.error_dialog('Bound branch is out of date: %s' % errmsg)
             return
         except:
             raise

=== modified file 'olive/frontend/gtk/push.py'
--- olive/frontend/gtk/push.py	2006-07-21 18:18:20 +0000
+++ olive/frontend/gtk/push.py	2006-07-24 14:32:01 +0000
@@ -85,10 +85,6 @@
             self.check_create.hide()
     
     def push(self, widget):
-        import bzrlib.ui as ui
-        from olive.backend.ui import GtkUIFactory
-        ui.ui_factory = GtkUIFactory()
-        
         from dialog import OliveDialog
         dialog = OliveDialog(self.gladefile)
         

